package edu.lawrence.registration.core;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

@Repository
public class EventDAO {

	@Autowired
	JdbcTemplate jdbcTemplate;
	
	public List<Event> getAllEvents() {
		String sql = "select * from events";
		RowMapper<Event> listRowMapper = new EventRowMapper();
		List<Event> results = jdbcTemplate.query(sql, listRowMapper);
		return results;
	}
	
	public List<Person> getPeopleForEvent(int id) {
		String sql = "select person from registrations where event=?";
		List<Integer> ids = jdbcTemplate.queryForList(sql,Integer.class,id);
		List<Person> results = new ArrayList<Person>();
		for(int personid : ids) {
			String personSQL = "select * from people where id=?";
			RowMapper<Person> personRowMapper = new PersonRowMapper();
			try {
				Person p = jdbcTemplate.queryForObject(personSQL,personRowMapper,personid);
				results.add(p);
			} catch(Exception ex) {
				
			}
		}
		return results;
	}
	
	/** Alternative One: **/
	public List<Person> getPeopleForEventAlternativeOne(int id) {
		String sql = "select id, firstname, lastname from people join registrations on people.id = registrations.person where event=?";
		RowMapper<Person> personRowMapper = new PersonRowMapper();
		List<Person> results = jdbcTemplate.query(sql,personRowMapper,id);
		return results;
	}
	
	/** Alternative Two: **/
	public List<Person> getPeopleForEventAlternativeTwo(int id) {
		String sql = "select * from people where id in (select person from registrations where event=?)";
		RowMapper<Person> personRowMapper = new PersonRowMapper();
		List<Person> results = jdbcTemplate.query(sql,personRowMapper,id);
		return results;
	}
}
