package edu.lawrence.registration.core;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;

@Repository
public class RegistrationDAO {
	@Autowired
	JdbcTemplate jdbcTemplate;
	
	public void saveRegistration(Registration registration) throws DuplicateException {
		String checkSQL = "select person from registrations where person=? and event=?";
		List<Integer> existing = jdbcTemplate.queryForList(checkSQL, Integer.class, registration.getPerson(), registration.getEvent());
		if(existing.size() > 0)
			throw new DuplicateException("Duplicate registration");
		
		String sql = "insert into registrations(person,event) values(?,?)";
		jdbcTemplate.update(sql,registration.getPerson(),registration.getEvent());
	}
}
