package edu.lawrence.registration.interfaces;

import java.util.List;

import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import edu.lawrence.registration.core.Event;
import edu.lawrence.registration.core.EventDAO;
import edu.lawrence.registration.core.Person;

@RestController
@RequestMapping("/events")
@CrossOrigin(origins = "*")
public class EventController {
	
	private EventDAO dao;
	
	public EventController(EventDAO dao) {
		this.dao = dao;
	}
	
	@GetMapping()
	public ResponseEntity<List<Event>> findAllEvents() {
		List<Event> events = dao.getAllEvents();
		return ResponseEntity.ok().body(events); 
	}
	
	@GetMapping("/{id}/people")
	public ResponseEntity<List<Person>> findPeopleForEvent(@PathVariable("id") int id) {
		List<Person> people = dao.getPeopleForEvent(id);
		return ResponseEntity.ok().body(people);
	}
}
