package edu.lawrence.registration.interfaces;

import java.util.List;

import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import edu.lawrence.registration.core.Person;
import edu.lawrence.registration.core.PersonDAO;

@RestController
@RequestMapping("/people")
@CrossOrigin(origins = "*")
public class PersonController {
	
	private PersonDAO dao;
	
	public PersonController(PersonDAO dao) {
		this.dao = dao;
	}
	
	@GetMapping()
	public ResponseEntity<List<Person>> findAllPeople() {
		List<Person> people = dao.getAllPeople();
		return ResponseEntity.ok().body(people); 
	}
}
