package edu.lawrence.registration.interfaces;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import edu.lawrence.registration.core.DuplicateException;
import edu.lawrence.registration.core.Registration;
import edu.lawrence.registration.core.RegistrationDAO;

@RestController
@RequestMapping("/registrations")
@CrossOrigin(origins = "*")
public class RegistrationController {
	
	private RegistrationDAO dao;
	
	public RegistrationController(RegistrationDAO dao) {
		this.dao = dao;
	}
	
	@PostMapping()
	public ResponseEntity<String> saveRegistration(@RequestBody Registration registration) {
		try {
			dao.saveRegistration(registration);
		} catch (DuplicateException ex) {
			return ResponseEntity.status(HttpStatus.CONFLICT).body("Duplicate registration");
		} catch (Exception ex) {
			ex.printStackTrace();
			return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body("Something went wrong");
		}
		return ResponseEntity.status(HttpStatus.CREATED).body("Registration entered");
	}
}
